%global distro  Circle Linux
%global major   8
%global minor   4


Name:           circle-linux-release
Version:        %{major}.%{minor}
Release:        3%{?dist}
Summary:        %{distro} release files
License:        GPLv2
URL:            https://cclinux.org
BuildArch:      noarch

Requires:       circle-linux-repos(%{major})

# required for a lorax run (to generate install media)
Provides:       circle-release-eula
Provides:       redhat-release-eula

# required by epel-release
Provides:       redhat-release = %{version}-%{release}

# required by dnf
# https://github.com/rpm-software-management/dnf/blob/4.2.23/dnf/const.py.in#L26
Provides:       system-release = %{version}-%{release}
Provides:       system-release(releasever) = %{major}

# required by libdnf
# https://github.com/rpm-software-management/libdnf/blob/0.48.0/libdnf/module/ModulePackage.cpp#L472
Provides:       base-module(platform:el%{major})

Source200:      EULA
Source201:      LICENSE
Source202:      Contributors

Source300:      85-display-manager.preset
Source301:      90-default.preset
Source302:      99-default-disable.preset

%description
%{distro} release files.

%install
# copy license and contributors doc here for %%license and %%doc macros
cp %{SOURCE201} %{SOURCE202} .

# create /etc/system-release and /etc/redhat-release
install -d -m 0755 %{buildroot}%{_sysconfdir}
echo "%{distro} release %{version}" > %{buildroot}%{_sysconfdir}/circle-release
echo "Derived from Red Hat Enterprise Linux %{version}" > %{buildroot}%{_sysconfdir}/circle-release-upstream
ln -s circle-release %{buildroot}%{_sysconfdir}/system-release
ln -s circle-release %{buildroot}%{_sysconfdir}/redhat-release

# Create the os-release file
install -d -m 0755 %{buildroot}%{_prefix}/lib
cat > %{buildroot}%{_prefix}/lib/os-release << EOF
NAME="%{distro}"
VERSION="%{major}"
ID="circle"
ID_LIKE="rhel fedora"
VERSION_ID="%{major}"
PLATFORM_ID="platform:el%{major}"
PRETTY_NAME="%{distro} %{major}"
ANSI_COLOR="0;31"
CPE_NAME="cpe:/o:circle:circle:%{major}"
HOME_URL="https://cclinux.org/"
BUG_REPORT_URL="https://bugs.cclinux.org/"
CENTOS_MANTISBT_PROJECT="Circle-%{major}"
CENTOS_MANTISBT_PROJECT_VERSION="%{major}"
EOF

# Create the symlink for /etc/os-release
ln -s ../usr/lib/os-release %{buildroot}%{_sysconfdir}/os-release

# write cpe to /etc/system/release-cpe
echo "cpe:/o:circle:circle:%{major}" > %{buildroot}%{_sysconfdir}/system-release-cpe

# create /etc/issue and /etc/issue.net
#echo '\S' > %{buildroot}%{_sysconfdir}/issue
#echo 'Kernel \r on an \m' >> %{buildroot}%{_sysconfdir}/issue
cat << EOF > %{buildroot}%{_sysconfdir}/issue
        +++++   +++         
    +++++=      +++    +           
   +++=             +++     
  :+++                       
  +++                    +   
 +++                        
 +++                        
 +++                        
 +++:                       
  +++                       
   +++               :+++     
    ++++            ++++     
      +++++++++++++++       
        -+++++++++.         

WARNING: THIS RELEASE IS NOT PRODUCTION READY.

\S -- TEST RELEASE -- EVALUATION ONLY
Kernel \r on an \m
EOF
cp %{buildroot}%{_sysconfdir}/issue{,.net}
echo >> %{buildroot}%{_sysconfdir}/issue

# set up the dist tag macros
install -d -m 0755 %{buildroot}%{_sysconfdir}/rpm
cat > %{buildroot}%{_sysconfdir}/rpm/macros.dist << EOF
# dist macros.

%%circle_ver %{major}
%%circle %{major}
%%centos %{major}
%%rhel %{major}
%%dist .el%{major}
%%el%{major} 1
EOF

# use unbranded datadir
install -d -m 0755 %{buildroot}%{_datadir}/circle-release
ln -s circle-release %{buildroot}%{_datadir}/redhat-release
install -p -m 0644 %{SOURCE200} %{buildroot}%{_datadir}/circle-release/

# copy systemd presets
install -d -m 0755 %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -p -m 0644 %{_sourcedir}/*.preset %{buildroot}%{_prefix}/lib/systemd/system-preset/


%files
%license LICENSE
%doc Contributors
%{_sysconfdir}/redhat-release
%{_sysconfdir}/system-release
%{_sysconfdir}/circle-release
%{_sysconfdir}/circle-release-upstream
%config(noreplace) %{_sysconfdir}/os-release
%config %{_sysconfdir}/system-release-cpe
%config(noreplace) %{_sysconfdir}/issue
%config(noreplace) %{_sysconfdir}/issue.net
%{_sysconfdir}/rpm/macros.dist
%{_datadir}/redhat-release
%{_datadir}/circle-release
%{_prefix}/lib/os-release
%{_prefix}/lib/systemd/system-preset/*
%ifarch %{arm} aarch64
%attr(0755,root,root) %{_bindir}/rootfs-expand
%endif


%changelog
* Tue Aug 10 2021 Bella Zhang <bella@cclinux.org> - 8.4-1
- Update version to 8.4

* Tue Mar 16 2021 earthloong <earthloong@cclinux.org> - 8.3-1
- Initial Circle Release 8.3 based on CentOS 8.3
- Keep centos rpm macro to reduce package modification burden
